# procedural programming way of doing things

circle1 = {"type":"circle", "name":"pepperoni", "radius":3.0}
circle2 = {"type":"circle", "name":"tomato", "radius":5.0}
square1 = {"type":"square", "name":"pizzabox", "side":10.0}
rectangle1 = {"type":"rectangle", "name":"oventray", "length":3.0, "width":8.0}

def computeArea(shape):
    if (shape["type"]=="circle"):
        return 3.14 * shape["radius"]**2
    elif (shape["type"]=="square"):
        return shape["side"]**2
    elif (shape["type"]=="rectangle"):
        return shape["length"]*shape["width"]

def circleArea(shape):
    return 3.14 * shape["radius"]**2

def squareArea(shape):
    return shape["side"]**2

def rectangleArea(shape):
    return shape["length"]*shape["width"]



# the OOP way

class Shape2D:
    def __init__(self, name):
        self.name = name
    def say_my_name(self):
        print(f"my name is {self.name}")

class Circle(Shape2D):
    def __init__(self, name, radius):
        super().__init__(name)
        self.radius = radius
    def area(self):
        return 3.14 * self.radius**2
    def circumference(self):
        return 3.14 * self.radius * 2
    def __str__(self):
        return f"I am a circle with radius {self.radius} and area {self.area()}"
    def __repr__(self):
        return f"Circle(name='{self.name}', radius={self.radius})"
    def __eq__(self, other):
        return (self.radius == other.radius)
    def __lt__(self, other):
        return (self.radius < other.radius)
    def __gt__(self, other):
        return (self.radius > other.radius)

class Square(Shape2D):
    def __init__(self, name, side):
        super().__init__(name)
        self.side = side
    def area(self):
        return self.side**2
    def circumference(self):
        return self.side * 4
    def __str__(self):
        return f"I am a square with side {self.side} and area {self.area()}"
    def __repr__(self):
        return f"Square(name='{self.name}', side={self.side})"
    def __eq__(self, other):
        return (self.side == other.side)
    def __lt__(self, other):
        return self.side < other.side
    def __gt__(self, other):
        return self.side > other.side
    
class Rectangle(Shape2D):
    def __init__(self,name,length,width):
        self.name = name
        self.length=length
        self.width=width
    def area(self):
        return self.length*self.width
    def __str__(self):
        return f"I am a rectangle with length {self.length} and width {self.width} and area {self.area()}"
    def __repr__(self):
        return f"Rectangle(name='{self.name}', length={self.length}, width={self.width})"
    def __eq__(self, other):
        return ((self.length==other.length) and (self.width==other.width))
    def __lt__(self, other):
        return self.area() < other.area()
    def __gt__(self, other):
        return self.area() > other.area()
    
circle1 = Circle(name="pepperoni", radius=3.0)
circle2 = Circle(name="tomato", radius=5.0)
square1 = Square(name="pizzabox", side=10.0)

my_shapes = [circle1, circle2, square1]

#def shapeSummary(shapes):
#    for s in shapes:
#        print(f"my name is {s.name} and my area is {s.area()}")

for s in my_shapes:
    print(s)

import copy


